#include <M5Stack.h>
//#include "Seeed_MCP9600.h"
#include <Wire.h>
#include <Adafruit_I2CDevice.h>
#include <Adafruit_I2CRegister.h>
#include "Adafruit_MCP9600.h"
#include "START_XBM.h"
#include "STOP_XBM.h"
#include "now_XBM.h"
#include "mode0_XBM.h"
#include "mode1_XBM.h"
#include "mode2_XBM.h"
#include "mode3_XBM.h"
#include "mode4_XBM.h"
#include "mode5_XBM.h"
#define SsrPin G26

#define mode1_Temp 140.0f
#define mode2_Temp 140.0f
#define mode2_TempWidth 5.0f
#define mode2_Time 90000 //90s
#define mode3_Temp 183.0f
#define mode4_Temp 200.0f
#define mode4_TempWidth 10.0f
#define mode4_Time 30000 //30s
#define mode5_Temp 183.0f
#define mode6_Temp 150.0f

TFT_eSprite spr_main0 = TFT_eSprite(&M5.Lcd);
TFT_eSprite spr_main1 = TFT_eSprite(&M5.Lcd);
TFT_eSprite spr_btnA = TFT_eSprite(&M5.Lcd);
TFT_eSprite spr_btnB = TFT_eSprite(&M5.Lcd);
TFT_eSprite spr_btnC = TFT_eSprite(&M5.Lcd);
TFT_eSprite spr_Graph = TFT_eSprite(&M5.Lcd);

unsigned long totalMillis = 0, mode2Millis = 0, mode4Millis = 0, mode5Millis = 0;
byte mode = 0;
//MCP9600 sensor;
#define I2C_ADDRESS (0x60)
Adafruit_MCP9600 mcp;
/**
  err_t sensor_basic_config()
  {
  err_t ret = NO_ERROR;
  CHECK_RESULT(ret, sensor.set_filt_coefficients(FILT_MID));
  CHECK_RESULT(ret, sensor.set_cold_junc_resolution(COLD_JUNC_RESOLUTION_0_25));
  CHECK_RESULT(ret, sensor.set_ADC_meas_resolution(ADC_16BIT_RESOLUTION));
  CHECK_RESULT(ret, sensor.set_burst_mode_samp(BURST_32_SAMPLE));
  CHECK_RESULT(ret, sensor.set_sensor_mode(NORMAL_OPERATION));
  return ret;
  }


  err_t get_temperature(float *value)
  {
  err_t ret = NO_ERROR;
  float hot_junc = 0;
  float junc_delta = 0;
  float cold_junc = 0;
  CHECK_RESULT(ret, sensor.read_hot_junc(&hot_junc));
  CHECK_RESULT(ret, sensor.read_junc_temp_delta(&junc_delta));

  CHECK_RESULT(ret, sensor.read_cold_junc(&cold_junc));

  // SERIAL.print("hot junc=");
  // SERIAL.println(hot_junc);
  // SERIAL.print("junc_delta=");
  // SERIAL.println(junc_delta);
  // SERIAL.print("cold_junc=");
  // SERIAL.println(cold_junc);

   value = hot_junc;

  return ret;
  }
**/
void btnAEnable() {
  spr_btnA.fillScreen(TFT_BLACK);
  spr_btnB.fillScreen(TFT_BLACK);
  spr_btnC.fillScreen(TFT_BLACK);
  spr_btnA.drawXBitmap(0, 0, START, START_width, START_height, TFT_WHITE);
  spr_btnB.drawXBitmap(0, 0, STOP, STOP_width, STOP_height, TFT_DARKGREY);
  spr_btnC.drawXBitmap(0, 0, STOP, STOP_width, STOP_height, TFT_DARKGREY);
  spr_btnA.pushSprite(40, 220);
  spr_btnB.pushSprite(130, 220);
  spr_btnC.pushSprite(220, 220);
}
void btnADisenable() {
  spr_btnA.fillScreen(TFT_BLACK);
  spr_btnB.fillScreen(TFT_BLACK);
  spr_btnC.fillScreen(TFT_BLACK);
  spr_btnA.drawXBitmap(0, 0, START, START_width, START_height, TFT_DARKGREY);
  spr_btnB.drawXBitmap(0, 0, STOP, STOP_width, STOP_height, TFT_WHITE);
  spr_btnC.drawXBitmap(0, 0, STOP, STOP_width, STOP_height, TFT_WHITE);
  spr_btnA.pushSprite(40, 220);
  spr_btnB.pushSprite(130, 220);
  spr_btnC.pushSprite(220, 220);
}

void setup() {
  M5.begin(true, false, true, true);
  M5.Speaker.setBeep(1000, 100);
  pinMode(SsrPin, OUTPUT);
  digitalWrite(SsrPin, HIGH);
  spr_main0.setColorDepth(8);
  spr_main1.setColorDepth(8);
  spr_btnA.setColorDepth(8);
  spr_btnB.setColorDepth(8);
  spr_btnC.setColorDepth(8);
  spr_Graph.setColorDepth(8);

  spr_main0.createSprite(160, 110);
  spr_main1.createSprite(160, 110);
  spr_btnA.createSprite(60, 20);
  spr_btnB.createSprite(60, 20);
  spr_btnC.createSprite(60, 20);
  spr_Graph.createSprite(320, 110);
  Serial.begin(115200);
  /**
    delay(10);
    Serial.println("serial start!!");
    if (sensor.init(THER_TYPE_K))
    {
    Serial.println("sensor init failed!!");
    }
    sensor_basic_config();
  **/
  if (! mcp.begin(I2C_ADDRESS)) {
    Serial.println("Sensor not found. Check wiring!");
    while (1);
  }

  Serial.println("Found MCP9600!");

  mcp.setADCresolution(MCP9600_ADCRESOLUTION_16);  //18-->16
  Serial.print("ADC resolution set to ");
  switch (mcp.getADCresolution()) {
    case MCP9600_ADCRESOLUTION_18:   Serial.print("18"); break;
    case MCP9600_ADCRESOLUTION_16:   Serial.print("16"); break;
    case MCP9600_ADCRESOLUTION_14:   Serial.print("14"); break;
    case MCP9600_ADCRESOLUTION_12:   Serial.print("12"); break;
  }
  Serial.println(" bits");

  mcp.setThermocoupleType(MCP9600_TYPE_K);
  Serial.print("Thermocouple type set to ");
  switch (mcp.getThermocoupleType()) {
    case MCP9600_TYPE_K:  Serial.print("K"); break;
    case MCP9600_TYPE_J:  Serial.print("J"); break;
    case MCP9600_TYPE_T:  Serial.print("T"); break;
    case MCP9600_TYPE_N:  Serial.print("N"); break;
    case MCP9600_TYPE_S:  Serial.print("S"); break;
    case MCP9600_TYPE_E:  Serial.print("E"); break;
    case MCP9600_TYPE_B:  Serial.print("B"); break;
    case MCP9600_TYPE_R:  Serial.print("R"); break;
  }
  Serial.println(" type");

  mcp.setFilterCoefficient(2); //3-->2
  Serial.print("Filter coefficient value set to: ");
  Serial.println(mcp.getFilterCoefficient());

  mcp.setAlertTemperature(1, 30);
  Serial.print("Alert #1 temperature set to ");
  Serial.println(mcp.getAlertTemperature(1));
  mcp.configureAlert(1, true, true);  // alert 1 enabled, rising temp

  mcp.enable(true);

  Serial.println(F("------------------------------"));
  btnAEnable();
}

void loop() {
  M5.update();
  // float temp = 0;
  // get_temperature(&temp);
  float temp = mcp.readThermocouple();
  if (M5.BtnB.wasPressed())
  { mode = 0;
    digitalWrite(SsrPin, LOW);
    M5.Speaker.beep();
    btnAEnable();
  }
  if (M5.BtnC.wasPressed())
  { mode = 0;
    digitalWrite(SsrPin, LOW);
    M5.Speaker.beep();
    btnAEnable();
  }
  if (digitalRead(SsrPin) == LOW)
    spr_main0.fillScreen(TFT_WHITE);
  else spr_main0.fillScreen(TFT_PINK);
  spr_main0.drawXBitmap(0, 0, now, now_width, now_height, TFT_BLACK);
  spr_main0.setTextColor(TFT_BLACK);
  spr_main0.setTextDatum(TR_DATUM);
  spr_main0.drawNumber(temp, 159, 27, 4);
  if (mode != 0) {
    spr_main0.drawNumber((millis() - totalMillis) / 1000, 159, 109, 4);
  }
  spr_main0.pushSprite(0, 0);

  //if (mode != 0)spr_main1.fillScreen(TFT_PINK);
  //else
  spr_main1.fillScreen(TFT_WHITE);

  switch (mode) {
    case 0: //待機状態
      digitalWrite(SsrPin, LOW);
      spr_main1.drawXBitmap(0, 0, mode0, mode0_width, mode0_height, TFT_BLUE);

      if (M5.BtnA.wasPressed())
      { mode = 1;
        btnADisenable();
        M5.Speaker.beep();
        totalMillis = millis();
        digitalWrite(SsrPin, HIGH);
        spr_Graph.fillScreen(TFT_BLACK);
        spr_Graph.drawLine(20, 0, 20, 100, TFT_WHITE);
        spr_Graph.drawLine(20, 100, 320, 100, TFT_WHITE);
        spr_Graph.setTextDatum(CR_DATUM);
        spr_Graph.setTextColor(TFT_WHITE);
        spr_Graph.drawString("100", 20, 100 - 100 / 2.5, 2);
        spr_Graph.drawString("200", 20, 100 - 200 / 2.5, 2);
        spr_Graph.drawLine(20, 100 - 183 / 2.5, 320, 100 - 183 / 2.5, TFT_RED);
      }
      break;
    case 1:  //昇温
      if (temp >= mode1_Temp) {
        mode = 2;
        mode2Millis = millis();
        M5.Speaker.beep();
      } else {
        spr_main1.drawXBitmap(0, 0, mode1, mode1_width, mode1_height, TFT_ORANGE);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.setTextColor(TFT_ORANGE);
        spr_main1.drawNumber(mode1_Temp, 159, 27, 4);
      }
      break;
    case 2://予熱ステージ
      if (millis() > (mode2Millis + mode2_Time)) {
        mode = 3;
        M5.Speaker.beep();
        digitalWrite(SsrPin, HIGH);
      } else {
        if (temp > (mode2_Temp + mode2_TempWidth / 2.0f))  digitalWrite(SsrPin, LOW);
        if (temp < (mode2_Temp + mode2_TempWidth / 2.0f))  digitalWrite(SsrPin, HIGH);
        spr_main1.drawXBitmap(0, 0, mode2, mode2_width, mode2_height, TFT_ORANGE);
        spr_main1.setTextColor(TFT_ORANGE);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.drawNumber(mode2_Temp, 159, 27, 4);
        spr_main1.drawNumber(mode2_Time / 1000, 159, 54, 4);
        spr_main1.drawNumber((millis() - mode2Millis) / 1000, 159, 82, 4)  ;
      }
      break;
    case 3:
      if (temp >= mode3_Temp) {
        mode = 4;
        mode4Millis = millis();
        M5.Speaker.beep();
      } else {
        spr_main1.drawXBitmap(0, 0, mode3, mode3_width, mode3_height, TFT_RED);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.setTextColor(TFT_RED);

        spr_main1.drawNumber(mode3_Temp, 159, 27, 4);

      }
      break;
    case 4://半田フローステージ
      if (millis() > (mode4Millis + mode4_Time)) {
        mode = 5;
        digitalWrite(SsrPin, LOW);
        M5.Speaker.beep();
      } else {
        if (temp > (mode4_Temp + mode4_TempWidth / 2.0f))  digitalWrite(SsrPin, LOW);
        if (temp < (mode4_Temp + mode4_TempWidth / 2.0f))  digitalWrite(SsrPin, HIGH);
        spr_main1.drawXBitmap(0, 0, mode4, mode4_width, mode4_height, TFT_RED);
        spr_main1.setTextColor(TFT_RED);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.drawNumber(mode4_Temp, 159, 27, 4);
        spr_main1.drawNumber(mode4_Time / 1000, 159, 54, 4);
        spr_main1.drawNumber((millis() - mode4Millis) / 1000, 159, 82, 4)    ;
      }
      break;
    case 5:
      if (temp < mode5_Temp) {
        mode = 6;
        mode5Millis = (millis() - mode4Millis) ;
        M5.Speaker.beep();
      } else {
        spr_main1.drawXBitmap(0, 0, mode5, mode5_width, mode5_height, TFT_RED);
        spr_main1.setTextColor(TFT_RED);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.drawNumber(mode5_Temp, 159, 27, 4);
        spr_main1.drawNumber((millis() - mode4Millis) / 1000, 159, 82, 4)    ;
      }
      break;
    case 6:
      if (temp < mode6_Temp) {
        mode = 0;
        M5.Speaker.beep();
        btnAEnable();
      } else {
        spr_main1.drawXBitmap(0, 0, mode5, mode5_width, mode5_height, TFT_RED);
        spr_main1.setTextColor(TFT_RED);
        spr_main1.setTextDatum(TR_DATUM);
        spr_main1.drawNumber(mode6_Temp, 159, 27, 4);
        spr_main1.drawNumber(mode5Millis / 1000, 159, 82, 4)    ;

      }
      break;
  }
  spr_main1.pushSprite(160, 0);
  //Graph
  if (mode != 0) {
    int x = (int)((millis() - totalMillis) / 2000ul) + 20;
    int y = 100 - (temp / 2.5);
    if (y < 0)y = 0;
    if (y > 109)y = 109;
    if (x > 320)x = 320;
    spr_Graph.drawPixel(x, y, TFT_WHITE);
  }
  spr_Graph.pushSprite(0, 110);

  /**
    static uint16_t scd30_n = 0;
    static uint16_t scd30_co2 = 0;
    static uint32_t scd30_co2_ave = 0;
    static float scd30_temp = 0;
    static float scd30_temp_ave = 0;
    static float scd30_rh = 0;
    static float scd30_rh_ave = 0;
    static uint16_t O2_n = 0;
    static float O2_ave = 0;
    static unsigned long old_millis = 300000ul; //5分
    if (millis() > 86400000ul) //24時間に１回リセット
    {
    NVIC_SystemReset();
    }
    if (millis() > old_millis) //5分ごとに記録
    {
    old_millis += 30000; //５分追加
    //MQTTに送信

    //初期化
    scd30_co2_ave = 0;
    scd30_temp_ave = 0;
    scd30_rh_ave = 0;
    scd30_n = 0;
    O2_n = 0;
    O2_ave = 0;
    }

    static int i = 0;
    //CO2Sensor
    bool scd30_success = true;
    if (scd30.dataAvailable())
    {
    scd30_co2 = scd30.getCO2();
    scd30_temp = scd30.getTemperature();
    scd30_rh = scd30.getHumidity();
    if ((scd30_co2 < 300) && (scd30_co2 > 3000))scd30_success = false;
    if ((scd30_temp < 0) && (scd30_temp > 35))scd30_success = false;
    if ((scd30_rh < 0) && (scd30_rh > 100))scd30_success = false;
    }
    if (scd30_success == true) {
    scd30_co2_ave += scd30_co2;
    scd30_temp_ave += scd30_temp;
    scd30_rh_ave += scd30_rh;
    scd30_n++;
    spr_scd30.fillScreen(TFT_BLACK);
    spr_scd30.setTextDatum(TL_DATUM);
    spr_scd30.drawString("SCD30 Sensor", 0, 0, 4);
    spr_scd30.drawString("CO2:", 10, 25, 4);
    spr_scd30.drawString("TEMP:", 10, 50, 4);
    spr_scd30.drawString("RH:", 10, 75, 4);
    spr_scd30.setTextDatum(TR_DATUM);
    spr_scd30.drawNumber(scd30_co2, 155, 25, 4);
    spr_scd30.drawFloat(scd30_temp, 1, 155, 50, 4);
    spr_scd30.drawFloat(scd30_rh, 1, 155, 75, 4);
    spr_scd30.pushSprite(0, 50);
    }



    //O2 Sensor
    long sum = 0;
    for (int i = 0; i < 32; i++) {
    sum += analogRead(A0);
    }
    sum >>= 5;
    float O2Vout = sum * (3.3 / 1023.0);
    float O2Percentage = O2Vout * 0.21 / 2.0 * 100;

    if (O2Percentage < 100) {
    O2_n++;
    O2_ave += O2Percentage;
    spr_O2.fillScreen(TFT_BLACK);
    spr_O2.setTextDatum(TL_DATUM);
    spr_O2.drawString("O2 Sensor", 0, 0, 4);
    spr_O2.drawString("O2:", 10, 25, 4);
    spr_O2.setTextDatum(TR_DATUM);
    spr_O2.drawFloat(O2Percentage, 1, 155, 25, 4);
    spr_O2.pushSprite(0, 170);
    }

    delay(DelayTime);
  **/
  delay(500);
}
